> For the complete documentation index, see [llms.txt](https://docs.ternoa.network/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ternoa.network/getting-started/javascript-sdk/ternoa-indexer/start-to-query/in-a-dapp.md).

# In a dApp

Here is the simplest example to request indexer data from a node application. We'll use the simple request used in the [playground section.](/getting-started/javascript-sdk/ternoa-indexer/start-to-query/using-a-playground.md)

#### First of all, in a new folder, create 2 files:

{% code title="package.json" %}

```json
{
  "name": "indexer-request-sample",
  "version": "1.0.0",
  "description": "",
  "main": "index.js",
  "type": "module",
  "scripts": {
    "test": "echo \"Error: no test specified\" && exit 1"
  },
  "author": "",
  "license": "ISC",
  "dependencies": {
    "graphql-request": "^5.0.0"
  }
}
```

{% endcode %}

{% code title="index.js" %}

```javascript
import { request } from "graphql-request"

const getLastListedNFTs = async () => {
	const gqlQuery = `{
	  nftEntities(
		first: 10, 
		offset: 0, 
		orderBy: TIMESTAMP_LIST_DESC
	  ) {
		totalCount
		nodes {
			nftId
			owner
			creator
			collectionId
			offchainData
    	}
	  }
	}`
	const response = await request("https://indexer-alphanet.ternoa.dev/", gqlQuery)
	if (response.nftEntities){
		console.log("Total count", response.nftEntities.totalCount)
		response.nftEntities.nodes.forEach(x => console.log(x))
	}
}

getLastListedNFTs()
```

{% endcode %}

Now open a terminal in this folder and run the following commands:

```bash
npm install
node index.js
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ternoa.network/getting-started/javascript-sdk/ternoa-indexer/start-to-query/in-a-dapp.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
